/***************************************************************************
 *   Copyright (C) 2005 by the G System Team                               *
 *   http://www.g-system.at                                                *
 *                                                                         *
 *   Permission is hereby granted, free of charge, to any person obtaining *
 *   a copy of this software and associated documentation files (the       *
 *   "Software"), to deal in the Software without restriction, including   *
 *   without limitation the rights to use, copy, modify, merge, publish,   *
 *   distribute, sublicense, and/or sell copies of the Software, and to    *
 *   permit persons to whom the Software is furnished to do so, subject to *
 *   the following conditions:                                             *
 *                                                                         *
 *   The above copyright notice and this permission notice shall be        *
 *   included in all copies or substantial portions of the Software.       *
 *                                                                         *
 *   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,       *
 *   EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF    *
 *   MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.*
 *   IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR     *
 *   OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, *
 *   ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR *
 *   OTHER DEALINGS IN THE SOFTWARE.                                       *
 ***************************************************************************/

/****************************************************************************
** Form implementation generated from reading ui file 'GweXmlConfiguratorBase.ui'
**
** Created: Sat Apr 2 20:28:26 2005
**      by: The User Interface Compiler ($Id: qt/main.cpp   3.3.4   edited Nov 24 2003 $)
**
****************************************************************************/

#include "GweXmlConfiguratorBase.h"

#include <qvariant.h>
#include <kpushbutton.h>
#include <qheader.h>
#include <klistview.h>
#include <kurlrequester.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>

/*
 *  Constructs a GOD::GweXmlConfiguratorBase as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 */
GOD::GweXmlConfiguratorBase::GweXmlConfiguratorBase( QWidget* parent, const char* name, WFlags fl )
    : QWidget( parent, name, fl )
{
    if ( !name )
	setName( "GOD::GweXmlConfiguratorBase" );
    GweXmlConfiguratorBaseLayout = new QGridLayout( this, 1, 1, 11, 6, "GweXmlConfiguratorBaseLayout"); 
    spacer1 = new QSpacerItem( 111, 21, QSizePolicy::Expanding, QSizePolicy::Minimum );
    GweXmlConfiguratorBaseLayout->addItem( spacer1, 2, 0 );

    ButtonSave = new KPushButton( this, "ButtonSave" );

    GweXmlConfiguratorBaseLayout->addWidget( ButtonSave, 2, 1 );

    ButtonReset = new KPushButton( this, "ButtonReset" );

    GweXmlConfiguratorBaseLayout->addWidget( ButtonReset, 2, 2 );

    OptionsTree = new KListView( this, "OptionsTree" );

    GweXmlConfiguratorBaseLayout->addMultiCellWidget( OptionsTree, 1, 1, 0, 2 );

    UrlRequester = new KURLRequester( this, "UrlRequester" );

    GweXmlConfiguratorBaseLayout->addMultiCellWidget( UrlRequester, 0, 0, 0, 2 );
    languageChange();
    resize( QSize(375, 315).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );
}

/*
 *  Destroys the object and frees any allocated resources
 */
GOD::GweXmlConfiguratorBase::~GweXmlConfiguratorBase()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void GOD::GweXmlConfiguratorBase::languageChange()
{
    setCaption( tr( "GWE Configurator" ) );
    QToolTip::add( this, tr( "The options of the current configuration" ) );
    QWhatsThis::add( this, tr( "This view displays the current state of the GWE options.<br>\n"
"You can choose various options and change their values\n"
"by clicking into the second column after selecting an item.\n"
"You can also change the description of an option if you want.<br>\n"
"After changing the value of an option the option tree is\n"
"automatically updated.<br>\n"
"For some options the available sub options depend on the\n"
"option value. For example the gwe_controller option has\n"
"different sub options for \"simple\" and \"advanced\"." ) );
    ButtonSave->setText( tr( "Sa&ve" ) );
    ButtonSave->setAccel( QKeySequence( tr( "Alt+V" ) ) );
    QToolTip::add( ButtonSave, tr( "Save the configuration" ) );
    QWhatsThis::add( ButtonSave, tr( "By clicking this button the current configuration is saved to the file given in the field at the top." ) );
    ButtonReset->setText( tr( "Rese&t" ) );
    ButtonReset->setAccel( QKeySequence( tr( "Alt+T" ) ) );
    QToolTip::add( ButtonReset, tr( "Reload the configuration from file" ) );
    QWhatsThis::add( ButtonReset, tr( "Reloads the configuration from the location given at the top.<br>\n"
"Note that unsaved data is lost. Generally this button is used to\n"
"return to the latest saved configuration." ) );
    QToolTip::add( UrlRequester, tr( "Choose the location of the configuration file" ) );
    QWhatsThis::add( UrlRequester, tr( "Set the location of the G World Engine configuration file.<br>\n"
"Note that choosen files are loaded at once after you press\n"
"enter or choose a file from the dialog. You should choose the\n"
"correct configuration file right at the beginning to avoid confusion\n"
"later on." ) );
}

